Entity Echo
Overview
The Entity Echo module provides functionality to clone entities (nodes and
taxonomy terms) and export them as YAML files. It is designed for content teams
to easily duplicate content and export data for reuse, with developer-friendly
debugging tools. YAML export uses the Symfony\Component\Yaml\Yaml class for
reliable serialization.

Features

Clone Entities: Duplicate nodes or taxonomy terms.
Export as YAML: Export nodes and taxonomy terms as YAML, with options to
download or copy to the clipboard.
Developer Debugging: Includes a YAML textarea for inspecting exported data.

Requirements

Drupal 10
Modules:
Node (drupal:node)
Taxonomy (drupal:taxonomy)


PHP Libraries:
symfony/yaml (included with Drupal core)



Installation

Download and enable the module:
drush en entity_echo


Clear the cache:
drush cr



Usage
Cloning Entities

Navigate to a node (/node/{nid}) or taxonomy term (/taxonomy/term/{tid}).
Click the "Echo Entity" link in the local tasks (requires Admin Toolbar).
Confirm cloning in the form and submit.
Redirects to the cloned entity's canonical URL.

Exporting Entities

Navigate to a node (/node/{nid}) or taxonomy term (/taxonomy/term/{tid}).
Click "Export Echo Node" or "Export Echo Term" in the local tasks.
Use the "Download YAML" button to save the YAML file or "Copy YAML" to copy to
the clipboard.
Developers can inspect the YAML in the textarea below the buttons.

Permissions

Use Entity Echo: Allows cloning and exporting nodes and taxonomy terms.
Users also need view access to entities (node.view, taxonomy_term.view).

Development
To ensure Drupal Coding Standards compliance, run:
phpcs --standard=Drupal,DrupalPractice modules/custom/entity_echo

Fix issues with:
phpcbf --standard=Drupal,DrupalPractice modules/custom/entity_echo

Roadmap

Hide YAML textarea for non-developer users.
Add automated tests (PHPUnit, Behat).
Improve import functionality.

License
GNU General Public License, version 2 or later (GPL-2.0+).
