(function ($, Drupal, once) {
  'use strict';

  Drupal.behaviors.entityEchoCopy = {
    attach: function (context) {
      // Find the copy button and attach click handler.
      once('entity-echo-copy', '#edit-copy', context).forEach(function () {
        var copyJson = $('#edit-copy', context);
        copyJson.on('click', function (event) {
          event.preventDefault();
          var textarea = $('#entity-export-json', context);
          var jsonContent = textarea.val();

          // Use navigator.clipboard API to copy text.
          navigator.clipboard.writeText(jsonContent).then(function () {
            // Show a success message.
            let button = $('#edit-copy');
            button.attr('value', "Copied!");
            button.addClass("copied");

            // Revert back to original state after 1 second
            setTimeout(() => {
              let button = $('#edit-copy');
              button.attr('value', "Copy");
              button.removeClass("copied");
            }, 1000);

          }).catch(function (err) {
            // Log error and show a warning.
            console.error('Failed to copy JSON: ', err);
          });
        });
      });
    }
  }
})(jQuery, Drupal, once);
