<?php

namespace Drupal\Tests\entity_echo\Unit;

use Drupal\Core\Entity\EntityTypeManagerInterface;
use Drupal\entity_echo\EntityCloner;
use Drupal\Tests\UnitTestCase;
use Drupal\node\Entity\Node;

/**
 * Tests the EntityCloner service.
 *
 * @group entity_echo
 */
class EntityClonerTest extends UnitTestCase {

  /**
   * Tests cloning a node.
   */
  public function testCloneNode() {
    $entity_type_manager = $this->createMock(EntityTypeManagerInterface::class);
    $cloner = new EntityCloner($entity_type_manager);

    $node = $this->createMock(Node::class);
    $node->method('getEntityTypeId')->willReturn('node');
    $node->expects($this->once())->method('createDuplicate')->willReturnSelf();
    $node->expects($this->any())->method('hasField')->willReturn(TRUE);
    $node->expects($this->any())->method('set')->willReturnSelf();
    $node->expects($this->once())->method('save');

    $cloned = $cloner->cloneEntity($node);
    $this->assertInstanceOf(Node::class, $cloned);
  }

}
